Loading...
Searching...
No Matches
CPE Dictionary
CPE
Collaboration diagram for CPE Dictionary:

## Files

file | cpe_dict.h
| Interface to Common Platform Enumeration (CPE) Dictionary.

## Data Structures

struct | cpe_dict_model
| Structure representing a CPE dictionary. More...
struct | cpe_item
| Structure representing single CPE dictionary item. More...
struct | cpe_vendor
| Structure with information about vendor. More...
struct | cpe_generator
| Structure with information about document. More...
struct | cpe_check
| Structure representing single CPE check. More...
struct | cpe_reference
| CPE dictionary item reference. More...
struct | cpe_item_metadata
| Structure representing metadata of CPE item. More...
struct | cpe_product
| Product of some vendor. More...
struct | cpe_version
| Version of product. More...
struct | cpe_update
| Update of product version. More...
struct | cpe_edition
| Edition of product update. More...
struct | cpe_language
| Language of product edition. More...
struct | cpe_item_iterator
| Iterator over CPE dictionary items. More...
struct | cpe_reference_iterator
| Iterator over CPE dictionary references. More...
struct | cpe_check_iterator
| Iterator over CPE dictionary checks. More...
struct | cpe_vendor_iterator
| Iterator over CPE dictionary item vendors. More...
struct | cpe_product_iterator
| Iterator over CPE dictionary item products. More...
struct | cpe_version_iterator
| Iterator over CPE dictionary item versions. More...
struct | cpe_update_iterator
| Iterator over CPE dictionary item updates. More...
struct | cpe_edition_iterator
| Iterator over CPE dictionary item editions. More...
struct | cpe_language_iterator
| Iterator over CPE dictionary item languages. More...

## Functions

OSCAP_API void | cpe_check::cpe_check_free (struct cpe_check *check)
OSCAP_API void | cpe_reference::cpe_reference_free (struct cpe_reference *ref)
OSCAP_API void | cpe_vendor::cpe_vendor_free (struct cpe_vendor *vendor)
OSCAP_API void | cpe_product::cpe_product_free (struct cpe_product *product)
OSCAP_API void | cpe_version::cpe_version_free (struct cpe_version *version)
OSCAP_API void | cpe_update::cpe_update_free (struct cpe_update *update)
OSCAP_API void | cpe_edition::cpe_edition_free (struct cpe_edition *edition)
OSCAP_API void | cpe_language::cpe_language_free (struct cpe_language *language)
OSCAP_API void | cpe_dict_model::cpe_dict_model_free (struct cpe_dict_model *dict)
OSCAP_API void | cpe_generator::cpe_generator_free (struct cpe_generator *generator)
OSCAP_API void | cpe_item::cpe_item_free (struct cpe_item *item)
OSCAP_API struct cpe_dict_model * | cpe_dict_model::cpe_dict_model_new (void)
OSCAP_API struct cpe_generator * | cpe_generator::cpe_generator_new (void)
OSCAP_API struct cpe_check * | cpe_check::cpe_check_new (void)
OSCAP_API struct cpe_reference * | cpe_reference::cpe_reference_new (void)
OSCAP_API struct cpe_item * | cpe_item::cpe_item_new (void)
OSCAP_API struct cpe_vendor * | cpe_vendor::cpe_vendor_new (void)
OSCAP_API struct cpe_product * | cpe_product::cpe_product_new (void)
OSCAP_API struct cpe_version * | cpe_version::cpe_version_new (void)
OSCAP_API struct cpe_update * | cpe_update::cpe_update_new (void)
OSCAP_API struct cpe_edition * | cpe_edition::cpe_edition_new (void)
OSCAP_API struct cpe_language * | cpe_language::cpe_language_new (void)
OSCAP_API struct cpe_item_metadata * | cpe_item_metadata::cpe_item_metadata_new (void)
OSCAP_API void | cpe_dict_model::cpe_dict_model_export (const struct cpe_dict_model *dict, const char *file)
| Write the dict_model to a file.
OSCAP_API struct cpe_dict_model * | cpe_dict_model::cpe_dict_model_import_source (struct oscap_source *source)
| Load new CPE dictionary from an oscap_source.

## Getters

Return value is pointer to structure's member. Do not free unless you null the pointer in the structure. Use remove function otherwise.
OSCAP_API const char * | cpe_item_metadata::cpe_item_metadata_get_modification_date (const struct cpe_item_metadata *item)
| cpe_item_metadata function to get date
OSCAP_API const char * | cpe_item_metadata::cpe_item_metadata_get_status (const struct cpe_item_metadata *item)
| cpe_item_metadata function to get status
OSCAP_API const char * | cpe_item_metadata::cpe_item_metadata_get_nvd_id (const struct cpe_item_metadata *item)
| cpe_item_metadata function to get nvd ID
OSCAP_API const char * | cpe_item_metadata::cpe_item_metadata_get_deprecated_by_nvd_id (const struct cpe_item_metadata *item)
| cpe_item_metadata function to get NVD ID of deprecated item
OSCAP_API const char * | cpe_check::cpe_check_get_system (const struct cpe_check *item)
| cpe_check functions to get system
OSCAP_API const char * | cpe_check::cpe_check_get_href (const struct cpe_check *item)
| cpe_check functions to get href
OSCAP_API const char * | cpe_check::cpe_check_get_identifier (const struct cpe_check *item)
| cpe_check functions to get identifier
OSCAP_API const char * | cpe_reference::cpe_reference_get_href (const struct cpe_reference *item)
| cpe_reference functions to get href of reference
OSCAP_API const char * | cpe_reference::cpe_reference_get_content (const struct cpe_reference *item)
| cpe_reference functions to get content of reference
OSCAP_API struct cpe_name * | cpe_item::cpe_item_get_name (const struct cpe_item *item)
| cpe_item functions to get variable member name
OSCAP_API struct cpe_name * | cpe_item::cpe_item_get_deprecated_by (const struct cpe_item *item)
| cpe_item functions to get variable member deprecated_by
OSCAP_API const char * | cpe_item::cpe_item_get_deprecation_date (const struct cpe_item *item)
| cpe_item functions to get variable member date
OSCAP_API struct cpe_item_metadata * | cpe_item::cpe_item_get_metadata (const struct cpe_item *item)
| cpe_item functions to get metadata of cpe_item
OSCAP_API struct cpe_reference_iterator * | cpe_item::cpe_item_get_references (const struct cpe_item *item)
| cpe_item functions to get CPE references
OSCAP_API struct cpe_check_iterator * | cpe_item::cpe_item_get_checks (const struct cpe_item *item)
| cpe_item functions to get CPE checks
OSCAP_API struct oscap_text_iterator * | cpe_item::cpe_item_get_titles (const struct cpe_item *item)
| cpe_item functions to get CPE titles
OSCAP_API const char * | cpe_generator::cpe_generator_get_product_name (const struct cpe_generator *item)
| cpe_generator functions to get product name
OSCAP_API const char * | cpe_generator::cpe_generator_get_product_version (const struct cpe_generator *item)
| cpe_generator functions to get product version
OSCAP_API const char * | cpe_generator::cpe_generator_get_schema_version (const struct cpe_generator *item)
| cpe_generator functions to get document schema version
OSCAP_API const char * | cpe_generator::cpe_generator_get_timestamp (const struct cpe_generator *item)
| cpe_generator functions to get timestamp from generator
OSCAP_API int | cpe_dict_model::cpe_dict_model_get_base_version (const struct cpe_dict_model *item)
| cpe_dict_model functions to get the base version from CPE dictionary model
OSCAP_API bool | cpe_dict_model::cpe_dict_model_set_base_version (struct cpe_dict_model *item, int base_version)
| cpe_dict_model functions to get the base version from CPE dictionary model
OSCAP_API struct cpe_generator * | cpe_generator::cpe_dict_model_get_generator (const struct cpe_dict_model *item)
| cpe_dict_model functions to get generator from CPE dictionary model
OSCAP_API struct cpe_item_iterator * | cpe_dict_model::cpe_dict_model_get_items (const struct cpe_dict_model *item)
| cpe_dict_model functions to get CPE items
OSCAP_API struct cpe_vendor_iterator * | cpe_dict_model::cpe_dict_model_get_vendors (const struct cpe_dict_model *item)
| cpe_dict_model functions to get vendors
OSCAP_API const char * | cpe_vendor::cpe_vendor_get_value (const struct cpe_vendor *item)
| cpe_vendor functions to get vendor value
OSCAP_API struct oscap_text_iterator * | cpe_vendor::cpe_vendor_get_titles (const struct cpe_vendor *item)
| cpe_vendor functions to get vendor titles
OSCAP_API struct cpe_product_iterator * | cpe_vendor::cpe_vendor_get_products (const struct cpe_vendor *item)
| cpe_vendor functions to get vendor products
OSCAP_API const char * | cpe_product::cpe_product_get_value (const struct cpe_product *item)
| cpe_product functions to get product value
OSCAP_API cpe_part_t | cpe_product::cpe_product_get_part (const struct cpe_product *item)
| cpe_product functions to get product part
OSCAP_API struct cpe_version_iterator * | cpe_version::cpe_product_get_versions (const struct cpe_product *item)
| cpe_product functions to get versions of product
OSCAP_API const char * | cpe_version::cpe_version_get_value (const struct cpe_version *item)
| cpe_version functions to get vupdates of versions
OSCAP_API struct cpe_update_iterator * | cpe_update::cpe_version_get_updates (const struct cpe_version *item)
| cpe_version functions to get value of version
OSCAP_API const char * | cpe_update::cpe_update_get_value (const struct cpe_update *item)
| cpe_update functions to get updates of version
OSCAP_API struct cpe_edition_iterator * | cpe_edition::cpe_update_get_editions (const struct cpe_update *item)
| cpe_update functions to get editions of update
OSCAP_API const char * | cpe_edition::cpe_edition_get_value (const struct cpe_edition *item)
| cpe_edition functions to get value of edition
OSCAP_API struct cpe_language_iterator * | cpe_language::cpe_edition_get_languages (const struct cpe_edition *item)
| cpe_edition functions to get languages of edition
OSCAP_API const char * | cpe_language::cpe_language_get_value (const struct cpe_language *item)
| cpe_language functions to get value of language

## Setters

For lists use add functions. Parameters of set functions are duplicated in memory and need to be freed by caller.
OSCAP_API bool | cpe_item::cpe_item_set_name (struct cpe_item *item, struct cpe_name *new_name)
OSCAP_API bool | cpe_item::cpe_item_set_deprecated_by (struct cpe_item *item, struct cpe_name *new_deprecated_by)
OSCAP_API bool | cpe_item::cpe_item_set_deprecation_date (struct cpe_item *item, const char *new_deprecation_date)
OSCAP_API bool | cpe_item_metadata::cpe_item_metadata_set_modification_date (struct cpe_item_metadata *item_metadata, const char *new_modification_date)
OSCAP_API bool | cpe_item_metadata::cpe_item_metadata_set_status (struct cpe_item_metadata *item_metadata, const char *new_status)
OSCAP_API bool | cpe_item_metadata::cpe_item_metadata_set_nvd_id (struct cpe_item_metadata *item_metadata, const char *new_nvd_id)
OSCAP_API bool | cpe_item_metadata::cpe_item_metadata_set_deprecated_by_nvd_id (struct cpe_item_metadata *item_metadata, const char *new_deprecated_by_nvd_id)
OSCAP_API bool | cpe_check::cpe_check_set_system (struct cpe_check *check, const char *new_system)
OSCAP_API bool | cpe_check::cpe_check_set_href (struct cpe_check *check, const char *new_href)
OSCAP_API bool | cpe_check::cpe_check_set_identifier (struct cpe_check *check, const char *new_identifier)
OSCAP_API bool | cpe_reference::cpe_reference_set_href (struct cpe_reference *reference, const char *new_href)
OSCAP_API bool | cpe_reference::cpe_reference_set_content (struct cpe_reference *reference, const char *new_content)
OSCAP_API bool | cpe_generator::cpe_generator_set_product_name (struct cpe_generator *generator, const char *new_product_name)
OSCAP_API bool | cpe_generator::cpe_generator_set_product_version (struct cpe_generator *generator, const char *new_product_version)
OSCAP_API bool | cpe_generator::cpe_generator_set_schema_version (struct cpe_generator *generator, const char *new_schema_version)
OSCAP_API bool | cpe_generator::cpe_generator_set_timestamp (struct cpe_generator *generator, const char *new_timestamp)
OSCAP_API bool | cpe_vendor::cpe_vendor_set_value (struct cpe_vendor *vendor, const char *new_value)
OSCAP_API bool | cpe_product::cpe_product_set_value (struct cpe_product *product, const char *new_value)
OSCAP_API bool | cpe_product::cpe_product_set_part (struct cpe_product *product, cpe_part_t new_part)
OSCAP_API bool | cpe_version::cpe_version_set_value (struct cpe_version *version, const char *new_value)
OSCAP_API bool | cpe_update::cpe_update_set_value (struct cpe_update *update, const char *new_value)
OSCAP_API bool | cpe_edition::cpe_edition_set_value (struct cpe_edition *edition, const char *new_value)
OSCAP_API bool | cpe_language::cpe_language_set_value (struct cpe_language *language, const char *new_value)
OSCAP_API bool | cpe_item::cpe_item_add_reference (struct cpe_item *item, struct cpe_reference *new_reference)
OSCAP_API bool | cpe_item::cpe_item_add_check (struct cpe_item *item, struct cpe_check *new_check)
OSCAP_API bool | cpe_item::cpe_item_add_title (struct cpe_item *item, struct oscap_text *new_title)
OSCAP_API bool | cpe_dict_model::cpe_dict_model_add_item (struct cpe_dict_model *dict, struct cpe_item *new_item)
OSCAP_API bool | cpe_dict_model::cpe_dict_model_add_vendor (struct cpe_dict_model *dict, struct cpe_vendor *new_vendor)
OSCAP_API bool | cpe_vendor::cpe_vendor_add_title (struct cpe_vendor *vendor, struct oscap_text *new_title)
OSCAP_API bool | cpe_vendor::cpe_vendor_add_product (struct cpe_vendor *vendor, struct cpe_product *new_product)
OSCAP_API bool | cpe_product::cpe_product_add_version (struct cpe_product *product, struct cpe_version *new_version)
OSCAP_API bool | cpe_version::cpe_version_add_update (struct cpe_version *version, struct cpe_update *new_update)
OSCAP_API bool | cpe_update::cpe_update_add_edition (struct cpe_update *update, struct cpe_edition *new_edition)
OSCAP_API bool | cpe_edition::cpe_edition_add_language (struct cpe_edition *edition, struct cpe_language *new_language)

## Iterators

OSCAP_API struct cpe_item * | cpe_item_iterator::cpe_item_iterator_next (struct cpe_item_iterator *it)
| Iterator over CPE dictionary items.
OSCAP_API bool | cpe_item_iterator::cpe_item_iterator_has_more (struct cpe_item_iterator *it)
| Iterator over CPE dictionary items.
OSCAP_API void | cpe_item_iterator::cpe_item_iterator_free (struct cpe_item_iterator *it)
| Iterator over CPE dictionary items.
OSCAP_API void | cpe_item::cpe_item_iterator_remove (struct cpe_item_iterator *it)
OSCAP_API void | cpe_item_iterator::cpe_item_iterator_reset (struct cpe_item_iterator *it)
OSCAP_API struct cpe_reference * | cpe_reference_iterator::cpe_reference_iterator_next (struct cpe_reference_iterator *it)
| Iterator over CPE item reference items.
OSCAP_API bool | cpe_reference_iterator::cpe_reference_iterator_has_more (struct cpe_reference_iterator *it)
| Iterator over CPE item reference items.
OSCAP_API void | cpe_reference_iterator::cpe_reference_iterator_free (struct cpe_reference_iterator *it)
| Iterator over CPE item reference items.
OSCAP_API void | cpe_reference_iterator::cpe_reference_iterator_remove (struct cpe_reference_iterator *it)
OSCAP_API void | cpe_reference_iterator::cpe_reference_iterator_reset (struct cpe_reference_iterator *it)
OSCAP_API struct cpe_check * | cpe_check_iterator::cpe_check_iterator_next (struct cpe_check_iterator *it)
| Iterator over CPE item check items.
OSCAP_API bool | cpe_check_iterator::cpe_check_iterator_has_more (struct cpe_check_iterator *it)
| Iterator over CPE item check items.
OSCAP_API void | cpe_check_iterator::cpe_check_iterator_free (struct cpe_check_iterator *it)
| Iterator over CPE item check items.
OSCAP_API void | cpe_check_iterator::cpe_check_iterator_remove (struct cpe_check_iterator *it)
OSCAP_API void | cpe_check_iterator::cpe_check_iterator_reset (struct cpe_check_iterator *it)
OSCAP_API struct cpe_vendor * | cpe_vendor_iterator::cpe_vendor_iterator_next (struct cpe_vendor_iterator *it)
| Iterator over CPE vendor items.
OSCAP_API bool | cpe_vendor_iterator::cpe_vendor_iterator_has_more (struct cpe_vendor_iterator *it)
| Iterator over CPE vendor items.
OSCAP_API void | cpe_vendor_iterator::cpe_vendor_iterator_free (struct cpe_vendor_iterator *it)
| Iterator over CPE vendor items.
OSCAP_API void | cpe_vendor_iterator::cpe_vendor_iterator_remove (struct cpe_vendor_iterator *it)
OSCAP_API void | cpe_vendor_iterator::cpe_vendor_iterator_reset (struct cpe_vendor_iterator *it)
OSCAP_API struct cpe_product * | cpe_product_iterator::cpe_product_iterator_next (struct cpe_product_iterator *it)
| Iterator over CPE product items.
OSCAP_API bool | cpe_product_iterator::cpe_product_iterator_has_more (struct cpe_product_iterator *it)
| Iterator over CPE product items.
OSCAP_API void | cpe_product_iterator::cpe_product_iterator_free (struct cpe_product_iterator *it)
| Iterator over CPE product items.
OSCAP_API void | cpe_product_iterator::cpe_product_iterator_remove (struct cpe_product_iterator *it)
OSCAP_API void | cpe_product_iterator::cpe_product_iterator_reset (struct cpe_product_iterator *it)
OSCAP_API struct cpe_version * | cpe_version_iterator::cpe_version_iterator_next (struct cpe_version_iterator *it)
| Iterator over CPE version items.
OSCAP_API bool | cpe_version_iterator::cpe_version_iterator_has_more (struct cpe_version_iterator *it)
| Iterator over CPE version items.
OSCAP_API void | cpe_version_iterator::cpe_version_iterator_free (struct cpe_version_iterator *it)
| Iterator over CPE version items.
OSCAP_API void | cpe_version_iterator::cpe_version_iterator_remove (struct cpe_version_iterator *it)
OSCAP_API void | cpe_version_iterator::cpe_version_iterator_reset (struct cpe_version_iterator *it)
OSCAP_API struct cpe_update * | cpe_update_iterator::cpe_update_iterator_next (struct cpe_update_iterator *it)
| Iterator over CPE update items.
OSCAP_API bool | cpe_update_iterator::cpe_update_iterator_has_more (struct cpe_update_iterator *it)
| Iterator over CPE update items.
OSCAP_API void | cpe_update_iterator::cpe_update_iterator_free (struct cpe_update_iterator *it)
| Iterator over CPE update items.
OSCAP_API void | cpe_update_iterator::cpe_update_iterator_remove (struct cpe_update_iterator *it)
OSCAP_API void | cpe_update_iterator::cpe_update_iterator_reset (struct cpe_update_iterator *it)
OSCAP_API struct cpe_edition * | cpe_edition_iterator::cpe_edition_iterator_next (struct cpe_edition_iterator *it)
| Iterator over CPE edition items.
OSCAP_API bool | cpe_edition_iterator::cpe_edition_iterator_has_more (struct cpe_edition_iterator *it)
| Iterator over CPE edition items.
OSCAP_API void | cpe_edition_iterator::cpe_edition_iterator_free (struct cpe_edition_iterator *it)
| Iterator over CPE edition items.
OSCAP_API void | cpe_edition_iterator::cpe_edition_iterator_remove (struct cpe_edition_iterator *it)
OSCAP_API void | cpe_edition_iterator::cpe_edition_iterator_reset (struct cpe_edition_iterator *it)
OSCAP_API struct cpe_language * | cpe_language_iterator::cpe_language_iterator_next (struct cpe_language_iterator *it)
| Iterator over CPE language items.
OSCAP_API bool | cpe_language_iterator::cpe_language_iterator_has_more (struct cpe_language_iterator *it)
| Iterator over CPE language items.
OSCAP_API void | cpe_language_iterator::cpe_language_iterator_free (struct cpe_language_iterator *it)
| Iterator over CPE language items.
OSCAP_API void | cpe_language_iterator::cpe_language_iterator_remove (struct cpe_language_iterator *it)
OSCAP_API void | cpe_language_iterator::cpe_language_iterator_reset (struct cpe_language_iterator *it)

## Evaluators

OSCAP_API const char * | cpe_dict_model::cpe_dict_model_supported (void)
| Get the newest supported version of CPE dictionary XML.
OSCAP_API bool | cpe_dict_model::cpe_name_match_dict (struct cpe_name *cpe, struct cpe_dict_model *dict)
| Verify wether given CPE is known according to specified dictionary.
OSCAP_API bool | cpe_dict_model::cpe_name_applicable_dict (struct cpe_name *cpe, struct cpe_dict_model *dict, cpe_check_fn cb, void *usr)
| Verify whether given CPE is applicable to current platform by evaluating checks associated with it.
OSCAP_API bool | cpe_item::cpe_item_is_applicable (struct cpe_item *item, cpe_check_fn cb, void *usr)

## Detailed Description

Class diagram

## Function Documentation

## cpe_check_get_href()

OSCAP_API const char * cpe_check_get_href | ( | const struct cpe_check * | item | ) |

cpe_check functions to get href

Parameters

  item | CPE check item

## cpe_check_get_identifier()

OSCAP_API const char * cpe_check_get_identifier | ( | const struct cpe_check * | item | ) |

cpe_check functions to get identifier

Parameters

  item | CPE check item

## cpe_check_get_system()

OSCAP_API const char * cpe_check_get_system | ( | const struct cpe_check * | item | ) |

cpe_check functions to get system

Parameters

  item | CPE check item

## cpe_check_iterator_free()

OSCAP_API void cpe_check_iterator_free | ( | struct cpe_check_iterator * | it | ) |

Iterator over CPE item check items.

See also
  oscap_iterator

## cpe_check_iterator_has_more()

OSCAP_API bool cpe_check_iterator_has_more | ( | struct cpe_check_iterator * | it | ) |

Iterator over CPE item check items.

See also
  oscap_iterator

## cpe_check_iterator_next()

OSCAP_API struct cpe_check * cpe_check_iterator_next | ( | struct cpe_check_iterator * | it | ) |

Iterator over CPE item check items.

See also
  oscap_iterator

## cpe_dict_model_export()

OSCAP_API void cpe_dict_model_export | ( | const struct cpe_dict_model * | dict,
|  | const char * | file )

Write the dict_model to a file.

Parameters

  dict | CPE Dict model

## cpe_dict_model_get_base_version()

OSCAP_API int cpe_dict_model_get_base_version | ( | const struct cpe_dict_model * | item | ) |

cpe_dict_model functions to get the base version from CPE dictionary model

The base version is the major CPE version, 1 or 2. These two versions differ in namespace when exporting so we have to remember which version we loaded.

CPE 1.0 also doesn't have cpe_generator structure inside so we can't get the version info from there.

Parameters

  item | dictionary model

## cpe_dict_model_get_generator()

OSCAP_API struct cpe_generator * cpe_dict_model_get_generator | ( | const struct cpe_dict_model * | item | ) |

cpe_dict_model functions to get generator from CPE dictionary model

Parameters

  item | dictionary model

## cpe_dict_model_get_items()

OSCAP_API struct cpe_item_iterator * cpe_dict_model_get_items | ( | const struct cpe_dict_model * | item | ) |

cpe_dict_model functions to get CPE items

Parameters

  item | dictionary model

## cpe_dict_model_get_vendors()

OSCAP_API struct cpe_vendor_iterator * cpe_dict_model_get_vendors | ( | const struct cpe_dict_model * | item | ) |

cpe_dict_model functions to get vendors

Parameters

  item | dictionary model

## cpe_dict_model_import_source()

OSCAP_API struct cpe_dict_model * cpe_dict_model_import_source | ( | struct oscap_source * | source | ) |

Load new CPE dictionary from an oscap_source.

Parameters

  source | The oscap_source to parse content from

Returns
  new dictionary or NULL

## cpe_dict_model_set_base_version()

OSCAP_API bool cpe_dict_model_set_base_version | ( | struct cpe_dict_model * | item,
|  | int | base_version )

cpe_dict_model functions to get the base version from CPE dictionary model

Parameters

  item | dictionary model

## cpe_dict_model_supported()

OSCAP_API const char * cpe_dict_model_supported | ( | void |  | ) |

Get the newest supported version of CPE dictionary XML.

Returns
  version of XML file format

## cpe_edition_get_languages()

OSCAP_API struct cpe_language_iterator * cpe_edition_get_languages | ( | const struct cpe_edition * | item | ) |

cpe_edition functions to get languages of edition

Parameters

  item | cpe_edition of update

## cpe_edition_get_value()

OSCAP_API const char * cpe_edition_get_value | ( | const struct cpe_edition * | item | ) |

cpe_edition functions to get value of edition

Parameters

  item | cpe_edition of update

## cpe_edition_iterator_free()

OSCAP_API void cpe_edition_iterator_free | ( | struct cpe_edition_iterator * | it | ) |

Iterator over CPE edition items.

See also
  oscap_iterator

## cpe_edition_iterator_has_more()

OSCAP_API bool cpe_edition_iterator_has_more | ( | struct cpe_edition_iterator * | it | ) |

Iterator over CPE edition items.

See also
  oscap_iterator

## cpe_edition_iterator_next()

OSCAP_API struct cpe_edition * cpe_edition_iterator_next | ( | struct cpe_edition_iterator * | it | ) |

Iterator over CPE edition items.

See also
  oscap_iterator

## cpe_generator_get_product_name()

OSCAP_API const char * cpe_generator_get_product_name | ( | const struct cpe_generator * | item | ) |

cpe_generator functions to get product name

Parameters

  item | document generator

## cpe_generator_get_product_version()

OSCAP_API const char * cpe_generator_get_product_version | ( | const struct cpe_generator * | item | ) |

cpe_generator functions to get product version

Parameters

  item | document generator

## cpe_generator_get_schema_version()

OSCAP_API const char * cpe_generator_get_schema_version | ( | const struct cpe_generator * | item | ) |

cpe_generator functions to get document schema version

Parameters

  item | document generator

## cpe_generator_get_timestamp()

OSCAP_API const char * cpe_generator_get_timestamp | ( | const struct cpe_generator * | item | ) |

cpe_generator functions to get timestamp from generator

Parameters

  item | document generator

## cpe_item_get_checks()

OSCAP_API struct cpe_check_iterator * cpe_item_get_checks | ( | const struct cpe_item * | item | ) |

cpe_item functions to get CPE checks

Parameters

  item | CPE item

## cpe_item_get_deprecated_by()

OSCAP_API struct cpe_name * cpe_item_get_deprecated_by | ( | const struct cpe_item * | item | ) |

cpe_item functions to get variable member deprecated_by

Parameters

  item | CPE item

## cpe_item_get_deprecation_date()

OSCAP_API const char * cpe_item_get_deprecation_date | ( | const struct cpe_item * | item | ) |

cpe_item functions to get variable member date

Parameters

  item | CPE item

## cpe_item_get_metadata()

OSCAP_API struct cpe_item_metadata * cpe_item_get_metadata | ( | const struct cpe_item * | item | ) |

cpe_item functions to get metadata of cpe_item

Parameters

  item | CPE item

## cpe_item_get_name()

OSCAP_API struct cpe_name * cpe_item_get_name | ( | const struct cpe_item * | item | ) |

cpe_item functions to get variable member name

Parameters

  item | CPE item

## cpe_item_get_references()

OSCAP_API struct cpe_reference_iterator * cpe_item_get_references | ( | const struct cpe_item * | item | ) |

cpe_item functions to get CPE references

Parameters

  item | CPE item

## cpe_item_get_titles()

OSCAP_API struct oscap_text_iterator * cpe_item_get_titles | ( | const struct cpe_item * | item | ) |

cpe_item functions to get CPE titles

Parameters

  item | CPE item

## cpe_item_iterator_free()

OSCAP_API void cpe_item_iterator_free | ( | struct cpe_item_iterator * | it | ) |

Iterator over CPE dictionary items.

See also
  oscap_iterator

## cpe_item_iterator_has_more()

OSCAP_API bool cpe_item_iterator_has_more | ( | struct cpe_item_iterator * | it | ) |

Iterator over CPE dictionary items.

See also
  oscap_iterator

## cpe_item_iterator_next()

OSCAP_API struct cpe_item * cpe_item_iterator_next | ( | struct cpe_item_iterator * | it | ) |

Iterator over CPE dictionary items.

See also
  oscap_iterator

## cpe_item_metadata_get_deprecated_by_nvd_id()

OSCAP_API const char * cpe_item_metadata_get_deprecated_by_nvd_id | ( | const struct cpe_item_metadata * | item | ) |

cpe_item_metadata function to get NVD ID of deprecated item

Parameters

  item | metadata of CPE item

## cpe_item_metadata_get_modification_date()

OSCAP_API const char * cpe_item_metadata_get_modification_date | ( | const struct cpe_item_metadata * | item | ) |

cpe_item_metadata function to get date

Parameters

  item | metadata of CPE item

## cpe_item_metadata_get_nvd_id()

OSCAP_API const char * cpe_item_metadata_get_nvd_id | ( | const struct cpe_item_metadata * | item | ) |

cpe_item_metadata function to get nvd ID

Parameters

  item | metadata of CPE item

## cpe_item_metadata_get_status()

OSCAP_API const char * cpe_item_metadata_get_status | ( | const struct cpe_item_metadata * | item | ) |

cpe_item_metadata function to get status

Parameters

  item | metadata of CPE item

## cpe_language_get_value()

OSCAP_API const char * cpe_language_get_value | ( | const struct cpe_language * | item | ) |

cpe_language functions to get value of language

Parameters

  item | language

## cpe_language_iterator_free()

OSCAP_API void cpe_language_iterator_free | ( | struct cpe_language_iterator * | it | ) |

Iterator over CPE language items.

See also
  oscap_iterator

## cpe_language_iterator_has_more()

OSCAP_API bool cpe_language_iterator_has_more | ( | struct cpe_language_iterator * | it | ) |

Iterator over CPE language items.

See also
  oscap_iterator

## cpe_language_iterator_next()

OSCAP_API struct cpe_language * cpe_language_iterator_next | ( | struct cpe_language_iterator * | it | ) |

Iterator over CPE language items.

See also
  oscap_iterator

## cpe_name_applicable_dict()

OSCAP_API bool cpe_name_applicable_dict | ( | struct cpe_name * | cpe,
|  | struct cpe_dict_model * | dict,
|  | cpe_check_fn | cb,
|  | void * | usr )

Verify whether given CPE is applicable to current platform by evaluating checks associated with it.

Parameters

  cpe | CPE to verify
  dict | used CPE dictionary

Returns
  true if dictionary contains given CPE and the CPE is applicable

## cpe_name_match_dict()

OSCAP_API bool cpe_name_match_dict | ( | struct cpe_name * | cpe,
|  | struct cpe_dict_model * | dict )

Verify wether given CPE is known according to specified dictionary.

Parameters

  cpe | CPE to verify
  dict | used CPE dictionary

Returns
  true if dictionary contains given CPE

## cpe_product_get_part()

OSCAP_API cpe_part_t cpe_product_get_part | ( | const struct cpe_product * | item | ) |

cpe_product functions to get product part

Parameters

  item | cpe_product

## cpe_product_get_value()

OSCAP_API const char * cpe_product_get_value | ( | const struct cpe_product * | item | ) |

cpe_product functions to get product value

Parameters

  item | cpe_product

## cpe_product_get_versions()

OSCAP_API struct cpe_version_iterator * cpe_product_get_versions | ( | const struct cpe_product * | item | ) |

cpe_product functions to get versions of product

Parameters

  item | cpe_product

## cpe_product_iterator_free()

OSCAP_API void cpe_product_iterator_free | ( | struct cpe_product_iterator * | it | ) |

Iterator over CPE product items.

See also
  oscap_iterator

## cpe_product_iterator_has_more()

OSCAP_API bool cpe_product_iterator_has_more | ( | struct cpe_product_iterator * | it | ) |

Iterator over CPE product items.

See also
  oscap_iterator

## cpe_product_iterator_next()

OSCAP_API struct cpe_product * cpe_product_iterator_next | ( | struct cpe_product_iterator * | it | ) |

Iterator over CPE product items.

See also
  oscap_iterator

## cpe_reference_get_content()

OSCAP_API const char * cpe_reference_get_content | ( | const struct cpe_reference * | item | ) |

cpe_reference functions to get content of reference

Parameters

  item | CPE reference item

## cpe_reference_get_href()

OSCAP_API const char * cpe_reference_get_href | ( | const struct cpe_reference * | item | ) |

cpe_reference functions to get href of reference

Parameters

  item | CPE reference item

## cpe_reference_iterator_free()

OSCAP_API void cpe_reference_iterator_free | ( | struct cpe_reference_iterator * | it | ) |

Iterator over CPE item reference items.

See also
  oscap_iterator

## cpe_reference_iterator_has_more()

OSCAP_API bool cpe_reference_iterator_has_more | ( | struct cpe_reference_iterator * | it | ) |

Iterator over CPE item reference items.

See also
  oscap_iterator

## cpe_reference_iterator_next()

OSCAP_API struct cpe_reference * cpe_reference_iterator_next | ( | struct cpe_reference_iterator * | it | ) |

Iterator over CPE item reference items.

See also
  oscap_iterator

## cpe_update_get_editions()

OSCAP_API struct cpe_edition_iterator * cpe_update_get_editions | ( | const struct cpe_update * | item | ) |

cpe_update functions to get editions of update

Parameters

  item | cpe_update of product element

## cpe_update_get_value()

OSCAP_API const char * cpe_update_get_value | ( | const struct cpe_update * | item | ) |

cpe_update functions to get updates of version

Parameters

  item |

## cpe_update_iterator_free()

OSCAP_API void cpe_update_iterator_free | ( | struct cpe_update_iterator * | it | ) |

Iterator over CPE update items.

See also
  oscap_iterator

## cpe_update_iterator_has_more()

OSCAP_API bool cpe_update_iterator_has_more | ( | struct cpe_update_iterator * | it | ) |

Iterator over CPE update items.

See also
  oscap_iterator

## cpe_update_iterator_next()

OSCAP_API struct cpe_update * cpe_update_iterator_next | ( | struct cpe_update_iterator * | it | ) |

Iterator over CPE update items.

See also
  oscap_iterator

## cpe_vendor_get_products()

OSCAP_API struct cpe_product_iterator * cpe_vendor_get_products | ( | const struct cpe_vendor * | item | ) |

cpe_vendor functions to get vendor products

Parameters

  item | cpe_vendor

## cpe_vendor_get_titles()

OSCAP_API struct oscap_text_iterator * cpe_vendor_get_titles | ( | const struct cpe_vendor * | item | ) |

cpe_vendor functions to get vendor titles

Parameters

  item | cpe_vendor

## cpe_vendor_get_value()

OSCAP_API const char * cpe_vendor_get_value | ( | const struct cpe_vendor * | item | ) |

cpe_vendor functions to get vendor value

Parameters

  item | cpe_vendor

## cpe_vendor_iterator_free()

OSCAP_API void cpe_vendor_iterator_free | ( | struct cpe_vendor_iterator * | it | ) |

Iterator over CPE vendor items.

See also
  oscap_iterator

## cpe_vendor_iterator_has_more()

OSCAP_API bool cpe_vendor_iterator_has_more | ( | struct cpe_vendor_iterator * | it | ) |

Iterator over CPE vendor items.

See also
  oscap_iterator

## cpe_vendor_iterator_next()

OSCAP_API struct cpe_vendor * cpe_vendor_iterator_next | ( | struct cpe_vendor_iterator * | it | ) |

Iterator over CPE vendor items.

See also
  oscap_iterator

## cpe_version_get_updates()

OSCAP_API struct cpe_update_iterator * cpe_version_get_updates | ( | const struct cpe_version * | item | ) |

cpe_version functions to get value of version

Parameters

  item | cpe_version

## cpe_version_get_value()

OSCAP_API const char * cpe_version_get_value | ( | const struct cpe_version * | item | ) |

cpe_version functions to get vupdates of versions

Parameters

  item | cpe_version

## cpe_version_iterator_free()

OSCAP_API void cpe_version_iterator_free | ( | struct cpe_version_iterator * | it | ) |

Iterator over CPE version items.

See also
  oscap_iterator

## cpe_version_iterator_has_more()

OSCAP_API bool cpe_version_iterator_has_more | ( | struct cpe_version_iterator * | it | ) |

Iterator over CPE version items.

See also
  oscap_iterator

## cpe_version_iterator_next()

OSCAP_API struct cpe_version * cpe_version_iterator_next | ( | struct cpe_version_iterator * | it | ) |

Iterator over CPE version items.

See also
  oscap_iterator